<?php

/**
 * @package TagGator Pro
 * @author پرشین اسکریپت
 * @version 2.0
 */
/*
Plugin Name: TagGator Pro!
Plugin URI: https://www.persianscript.ir
Description: TagGator is an auto tagging plugin, provide the plugin with some keywords, it will convert these keywords to tags and automatically adds this tag to all posts containing these keywords. 
Author: پرشین اسکریپت
Version: 2.0
Author URI: https://www.persianscript.ir
*/
if (!function_exists('add_action')) {
    //someone is trying to execute the plugin outside of WordPress
    die();
}
register_activation_hook(plugin_basename(__FILE__), 'taggator_install');
register_uninstall_hook(plugin_basename(__FILE__), 'taggator_uninstall');

add_action('admin_menu', 'taggator_menu');
add_action('save_post', 'autotagativator', 10, 2);
add_action('admin_head', 'timedtag');
add_action('clientsidei', '0');
function autotagativator($post_ID, $postcont = '')
{
    if (get_option('taggatorauto')) {
        $res = autotag($post_ID);
    }
    return $postcont;
}
function timedtag()
{
    $screen = get_current_screen();

    if ($screen->id == "settings_page_taggator-pro/taggatorpro") {
        wp_register_script('codemirror', plugin_dir_url(__FILE__) . 'js/codemirror/lib/codemirror.js');
        wp_enqueue_script('codemirror');
        wp_register_script('codemirrormode', plugin_dir_url(__FILE__) . 'js/codemirror/addon/mode/simple.js');
        wp_enqueue_script('codemirrormode');
        wp_register_script('codemirrorplugin', plugin_dir_url(__FILE__) . 'js/codemirror/mode/taggator/taggator.js');
        wp_enqueue_script('codemirrorplugin');
        wp_register_style('codemirror', plugin_dir_url(__FILE__) . 'js/codemirror/lib/codemirror.css');
        wp_enqueue_style('codemirror');
        wp_register_script('bootstrapjs', plugins_url('js/bootstrap/bootstrap.min.js', __FILE__), array('jquery'));
        wp_enqueue_script('bootstrapjs', "", array(), false, true);
        wp_register_style('bootstrapcss', plugin_dir_url(__FILE__) . 'js/bootstrap/bootstrap.min.css');
        wp_enqueue_style('bootstrapcss');
        wp_register_style('bootstraptoggle', plugin_dir_url(__FILE__) . 'js/bootstrap4-toggle-master/bootstrap4-toggle.min.css');
        wp_enqueue_style('bootstraptoggle');
        wp_register_script('bootstraptoggle', plugins_url('js/bootstrap4-toggle-master/bootstrap4-toggle.min.js', __FILE__), array('jquery'));
        wp_enqueue_script('bootstraptoggle', "", array(), false, true);
        wp_register_style('taggator', plugin_dir_url(__FILE__) . 'taggator.css');
        wp_enqueue_style('taggator');

        if (isset($_POST["starts"])) {
            $opt = 1000;
            update_option('clientsidei', '0');
            echo <<< OES
    
    <script type="text/javascript" >
    var int;
        jQuery(document).ready(function() { 
        jQuery('<div id = "showcount" class="updated"></div>').insertAfter(".taggator-title");
         int=self.setInterval("clock()",$opt);
    });
    
    function clock(){
    jQuery(document).ready(function($) {
         
        var data = {
            action: 'timedsender'
        };  
        jQuery.post(ajaxurl, data, function(response) {
            if((response=="-1") || (response=="fail"))
         int=window.clearInterval(int);
              
            var ce = document.getElementById("showcount").innerHTML;
            
            if((response !== '-1'))
                ce =  response;
                if((response == '-1'))
                ce =  "Tags processing Finished! You may close this page now.";
           document.getElementById("showcount").innerHTML = ce;
           
            
        });
    });
    }
    </script>
OES;
        }
    }
}
add_action('wp_ajax_timedsender', 'clienttagger');
function clienttagger()
{
    global $wpdb;
    $opt     = get_option("clientsidei");
    $cpt_settings = get_option('taggator_post_types');
    $enabled_post_types = array();
    foreach ($cpt_settings as $key => $value) {

        if ($cpt_settings[$key]["enabled"]) array_push($enabled_post_types, "'" . $key . "'");
    }
    $enabled_string = implode(",", $enabled_post_types);
    $pfx     = $wpdb->prefix;
    $myposts = $wpdb->get_col("SELECT id FROM `{$pfx}posts` WHERE `post_status` = 'publish' AND post_type in ($enabled_string) AND id > $opt limit 10");

    if (count($myposts) == 0) {
        echo '-1';
        die();
    }
    $nofmatchs = 0;

    foreach ($myposts as $pst) {
        $nofmatchs = $nofmatchs + autotag($pst);
    }
    update_option('clientsidei', $pst);

    echo "Processing post ID $pst";
    die();
}
function autotag($post_ID)
{
    $serv        = get_option('siteurl') . '/wp-content/plugins/' . plugin_basename(dirname(__file__));
    $tagall      = get_option('taggatortags');
    $cst         = get_option('taggatorcs');
    $mhw         = get_option('taggatormhw');
    $tagtit      = get_option('taggatortagtitle');

    $tagzl       = explode("\n", $tagall);
    $appliedtags = 0;
    $rc          = get_option('taggatorminbody');
    $rt          = get_option('taggatormintitle');

    $tmatches           = array();
    $zepost             = get_post($post_ID);
    $cpt_settings = get_option('taggator_post_types');
    if ($cpt_settings[$zepost->post_type]["enabled"] != 1) return 0;

    $custom_tax = $cpt_settings[$zepost->post_type]["selected_tag"];

    $tagg_content       = normalize_str($zepost->post_content);
    $tagg_title         = normalize_str($zepost->post_title);
    $tagg_content       = str_replace('$', '\\$', $tagg_content);
    $tagg_title         = str_replace('$', '\\$', $tagg_title);
    $small_tagg_content = strtolower($tagg_content);
    $small_tagg_title   = strtolower($tagg_title);



    if (!$cst)
        $regu = "/iu";
    if ($cst)
        $regu = "/u";
    foreach ($tagzl as $tagz) {

        $tagz        = explode(",", $tagz);
        $maintag     = $tagz[0];
        $total_cont  = 0;
        $total_title = 0;

        foreach ($tagz as $atag) {
            $atag = trim($atag);
            if ($atag <> '') {

                $ido = $post_ID;

                $atag = normalize_str($atag);
                $atag = strtolower($atag);

                if ($mhw) {
                    $total_cont  = $total_cont + (preg_match_all("/\b{$atag}s?\b$regu", ($tagg_content), $tmatches));
                    $total_title = $total_title + (preg_match_all("/\b{$atag}s?\b$regu", ($tagg_title), $tmatches));
                } else {
                    if ($cst) {
                        $total_cont  = $total_cont + substr_count($tagg_content, $atag);
                        $total_title = $total_title + substr_count($tagg_title, $atag);
                    } else {
                        $total_cont  = $total_cont + substr_count(($small_tagg_content), strtolower($atag));
                        $total_title = $total_title + substr_count($small_tagg_title, strtolower($atag));
                    }
                }

                if (get_option('taggatorbodyandtitle') == 1) {
                    $match_condition = (($total_cont >= $rc)) && (($total_title >= $rt));
                } else {
                    $match_condition = (($total_cont >= $rc) && ($rc > 0)) || (($total_title >= $rt) && ($rt > 0));
                }

                if ($match_condition) {

                    $atag = trim($maintag);

                    $appliedtags = $appliedtags + 1;

                    if ($zepost->post_type == 'post') {
                        wp_set_post_tags($ido, $atag, TRUE);
                    } else {
                        wp_set_post_terms($ido, $atag, $custom_tax, TRUE);
                    }




                    break;
                }
            }
        }
    }
    return $appliedtags;
}
function taggator_menu()
{

    add_options_page('TagGator Auto-Tagger', 'TagGator Pro', 'edit_pages', __file__, 'taggator_plugin_options');
}


function taggator_plugin_options()
{

    echo '<div class="wrap">';
    global $wpdb;
    $pfx  = $wpdb->prefix;
    $serv = "";
    $cpt = taggator_get_custom_post_tags();
    $cpt_settings = array();
    if (isset($_POST["tageditor"])) {

        foreach ($cpt as $key => $value) {
            if (isset($_POST[$key . "_selected_tag"])) if (in_array(sanitize_text_field($_POST[$key . "_selected_tag"]), $value)) {
                $cpt_settings[$key]["selected_tag"] = sanitize_text_field($_POST[$key . "_selected_tag"]);
            }
            if (isset($_POST[$key . "_enabled"])) if (sanitize_text_field($_POST[$key . "_enabled"]) == "on") {
                $cpt_settings[$key]["enabled"] = 1;
            }
        }
        $cst = 0;
        if (isset($_POST["cst"])) if (sanitize_text_field($_POST["cst"]) == "on")
            $cst = 1;

        $mhw = 0;
        if (isset($_POST["mhw"]))  if (sanitize_text_field($_POST["mhw"]) == "on")
            $mhw = 1;
        $mhwauto = 0;
        if (isset($_POST["autotag"]))  if (sanitize_text_field($_POST["autotag"]) == "on")
            $mhwauto = 1;
        $autit = 0;
        if (isset($_POST["taggatortagtitle"]))   if (sanitize_text_field($_POST["taggatortagtitle"]) == "on")
            $autit = 1;
        $taggatorbodyandtitle = 0;
        if (isset($_POST["taggatorbodyandtitle"]))   if (sanitize_text_field($_POST["taggatorbodyandtitle"]) == "on")
            $taggatorbodyandtitle = 1;

        if (isset($_POST["cont_matches"]))     $cont_matches = sanitize_text_field($_POST["cont_matches"]);
        if (isset($_POST["tit_matches"]))     $tit_matches  = sanitize_text_field($_POST["tit_matches"]);

        update_option('taggatorauto', $mhwauto);
        update_option('taggatorcs', $cst);
        update_option('taggatormhw', $mhw);
        update_option('taggatortagtitle', $autit);
        update_option('taggatorbodyandtitle', $taggatorbodyandtitle);
        if (is_numeric($cont_matches))
            update_option('taggatorminbody', $cont_matches);
        if (is_numeric($tit_matches))
            update_option('taggatormintitle', $tit_matches);
        $tagz = stripslashes(($_POST["tageditor"]));
        update_option('taggatortags', $tagz);
        $tagz = explode(',', $tagz);
        update_option('taggator_post_types', $cpt_settings);
        echo "<div class='updated'>Settings were saved  successfully.</div>";
    }


    if (isset($_POST["applynow"])) {

        $myposts   = $wpdb->get_col("SELECT id FROM `{$pfx}posts` WHERE ((`post_type` = 'post') or (`post_type` = 'product') )  AND `post_status` = 'publish'");
        $nofmatchs = 0;

        foreach ($myposts as $pst) {
            $nofmatchs = $nofmatchs + autotag($pst);
        }
        echo "<div class='updated'>$nofmatchs tags were applied to your posts by Taggator Pro!</div>";
    }
    $serv                 = str_replace('%7E', '~', $_SERVER['REQUEST_URI']);
    $plugurl              = plugin_dir_url(__file__);
    $chkd                 = checked(get_option('taggatorcs'), 1, 0);
    $chkd2                = checked(get_option('taggatormhw'), 1, 0);
    $chkdauto             = checked(get_option('taggatorauto'), 1, 0);
    $chkdtit              = checked(get_option('taggatortagtitle'), 1, 0);
    $taggatorbodyandtitle = checked(get_option('taggatorbodyandtitle'), 1, 0);
    $oldtags              = stripslashes(get_option('taggatortags'));
    $cpt_settings = get_option('taggator_post_types');
    echo <<< EOST
           <div id='icon-edit' class='icon32'></div><h2 class= 'taggator-title'>TagGator Pro!</h2>

EOST;

    $rc = get_option('taggatorminbody');
    $rt = get_option('taggatormintitle');
    if (isset($_POST["starts"])) {
        $vis = "visiblehidden";
    } else {
        $vis = "hidden";
    }

?>

    <div class="card ">
        <div class="card-header">
            Settings
        </div>
        <div class="card-body ">
            <h5 class="card-title">Tag list</h5>
            <Form method='post' action='<?php echo $serv; ?>'><textarea style='overflow: scroll;' name='tageditor' id='tageditor' cols='80' rows='10'><?php echo $oldtags; ?></textarea>
                <br />
                <script>
                    jQuery(document).ready(function() {

                        var editor = CodeMirror.fromTextArea(document.getElementById('tageditor'), {
                            lineNumbers: true,
                            mode: 'taggator'
                        });
                    });
                </script>
                <h5 class="card-title">Tag matching settings</h5>

                <input id='cst' name='cst' type='checkbox' <?php echo $chkd; ?> data-toggle='toggle' data-onstyle='primary'> <label for='cst' class='form-check-label'>Case Sensitive.</label><br />
                <input id='mhw' name='mhw' type='checkbox' <?php echo $chkd2; ?> data-toggle='toggle' data-onstyle='primary'> <label for='mhw' class='form-check-label'>Match whole words only.</label><br />
                <input id='taggatortagtitle' name='taggatortagtitle' type='checkbox' <?php echo $chkdtit; ?> data-toggle='toggle' data-onstyle='primary'> <label for='taggatortagtitle' class='form-check-label'>Scan post titles for keywords?.</label><br />
                <input id='autotag' name='autotag' type='checkbox' <?php echo $chkdauto; ?> data-toggle='toggle' data-onstyle='primary'> <label for='autotag' class='form-check-label'>Auto tag new posts?</label><br />
                <div class='form-group row'>
                    <label for='cont_matches' class='col-2 col-form-label'>Find at least</label>
                    <div class='col-2'>
                        <input class='form-control' type='number' id='cont_matches' name='cont_matches' value='<?php echo $rc; ?>' id='example-number-input'>
                    </div>
                    <label for='cont_matches' class='col-8 col-form-label'>matches in the contents.</label>
                </div>

                <div class='form-group row'>
                    <label for='tit_matches' class='col-2 col-form-label'>Find at least</label>
                    <div class='col-2'>
                        <input class='form-control' type='number' name='tit_matches' id='tit_matches' value='<?php echo $rt; ?>' id='example-number-input'>
                    </div>
                    <label for='tit_matches' class='col-8 col-form-label'>in the title.</label>
                </div>
                <input type='checkbox' title='Require Title and Contents matches?' name='taggatorbodyandtitle' id='taggatorbodyandtitle' <?php echo $taggatorbodyandtitle; ?> /> Must meet the minimum number to matches in both the title & contents instead of either of them. <br /><br />
                <h5 class="card-title">Custom post type settings</h5>
                <table class="table">
                    <thead>
                        <tr>
                            <th scope="col">Custom Post type</th>
                            <th scope="col">Enabled</th>
                            <th scope="col">Custom Taxonomy</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <?php
                            foreach ($cpt as $key => $value) {
                                $enabled = checked($cpt_settings[$key]["enabled"], 1, 0);
                            ?>
                                <th scope="row"><?php echo $key; ?></th>
                                <td><input id='<?php echo $key . "_enabled"; ?>' name='<?php echo $key . "_enabled"; ?>' type='checkbox' <?php echo $enabled; ?> data-toggle='toggle' data-onstyle='primary'> </td>
                                <td><select name='<?php echo $key . "_selected_tag"; ?>' class="form-control">
                                        <?php foreach ($value as $k => $v) {
                                            $sel = "";
                                            if ($v == $cpt_settings[$key]["selected_tag"]) $sel = "selected";
                                        ?>
                                            <option value="<?php echo $v; ?>" <?php echo $sel; ?>><?php echo $v; ?></option>
                                        <?php } ?>
                                    </select></td>
                        </tr>

                    <?php } ?>

                    </tbody>
                </table>



                <input type='submit' class='button-primary widget-control-save' value='Save' style='width:250px'> </form>
        </div>
    </div>

    <div class="card">
        <div class="card-header">
            Manual Tagging
        </div>
        <div class="card-body">
            <h5 class="card-title">Start a manual tagging job</h5>
            <Form method='post' action='<?php echo $serv; ?>'><input type='hidden' value='applynow' name='applynow' id='applynow' /><input class='btn button-primary widget-control-save' type='submit' value='Apply tags now' style='width:250px'></form>
            <Form method='post' action=''>
                <input type='submit' id='mailersb' value='Apply Tags Now (client side)' style='width:250px' class='button-primary widget-control-save'><Span style='font-size:8px;color:gray'>(Uses AJAX to control the process of tagging all posts, useful to reduce server load if you have a large number of posts and tags).<input type='hidden' value='starts' name='starts' id='starts' /></form><br />
        </div>
    </div>

    <div class="card">
        <div class="card-header">
            Help
        </div>
        <div class="card-body">
            <h5 class="card-title">Quick Start guide</h5>
            <p style='font-size: 100%; width:860px'>TagGator automatically searches post contents for keywords and then tags these posts accordingly. <br /> The First keyword in a line is the main tag, matching any keyword from the same line will tag the matched post with the main tag.<br />Each tag is entered in a separate line, followed by sub keywords separated by commas (,)<br />
                <h5>Example</h5><br /><b>
                    cities,sydney,london,paris,berlin<br />
                    animals,dog,cat,horse,labradoodle<br /></b>
                <br />For the first line, the main tag is (cities) so any post containing the keywords: cities,sydney,london,paris,or berlin will be tagged with the main tag (cities).<br />
                If your post containes contains any text like:<br /><br />
                <b>The latest Labradoodle race was held in paris last summer.</b><br /><br />
                Then your post will be automatically tagged with tags (cities) and (animals)<br />
                <br />
                You can change the number of keywords matches required to be found in the post body and title to have less, but more refined tagging.
                <br /><br />
                Take some time to write the tags list based on your website contents, once you're done, you'll never have to worry about tagging posts again.
            </p>
        </div>
    </div>
<?php
}

function taggator_get_custom_post_tags()
{
    $customtags = array();
    global $wp_post_types;
    foreach ($wp_post_types as $key => $value) {
        if ($value->public == true) {
            $taxonomies =  get_object_taxonomies($value->name);
            if (count($taxonomies) > 0) $customtags[$key] =  $taxonomies;
        }
    }
    return  $customtags;
}
function normalize_str($str)
{
    $invalid = array(
        'Š' => 'S', 'š' => 's', 'Đ' => 'Dj', 'đ' => 'dj', 'Ž' => 'Z', 'ž' => 'z',
        'Č' => 'C', 'č' => 'c', 'Ć' => 'C', 'ć' => 'c', 'À' => 'A', 'Á' => 'A', 'Â' => 'A', 'Ã' => 'A',
        'Ä' => 'A', 'Å' => 'A', 'Æ' => 'A', 'Ç' => 'C', 'È' => 'E', 'É' => 'E', 'Ê' => 'E', 'Ë' => 'E',
        'Ì' => 'I', 'Í' => 'I', 'Î' => 'I', 'Ï' => 'I', 'Ñ' => 'N', 'Ò' => 'O', 'Ó' => 'O', 'Ô' => 'O',
        'Õ' => 'O', 'Ö' => 'O', 'Ø' => 'O', 'Ù' => 'U', 'Ú' => 'U', 'Û' => 'U', 'Ü' => 'U', 'Ý' => 'Y',
        'Þ' => 'B', 'ß' => 'Ss', 'à' => 'a', 'á' => 'a', 'â' => 'a', 'ã' => 'a', 'ä' => 'a', 'å' => 'a',
        'æ' => 'a', 'ç' => 'c', 'è' => 'e', 'é' => 'e', 'ê' => 'e',  'ë' => 'e', 'ì' => 'i', 'í' => 'i',
        'î' => 'i', 'ï' => 'i', 'ð' => 'o', 'ñ' => 'n', 'ò' => 'o', 'ó' => 'o', 'ô' => 'o', 'õ' => 'o',
        'ö' => 'o', 'ø' => 'o', 'ù' => 'u', 'ú' => 'u', 'û' => 'u', 'ý' => 'y',  'ý' => 'y', 'þ' => 'b',
        'ÿ' => 'y', 'Ŕ' => 'R', 'ŕ' => 'r', "`" => "'", "´" => "'", "„" => ",", "`" => "'",
        "´" => "'", "“" => "\"", "”" => "\"", "´" => "'", "&acirc;€™" => "'", "{" => "",
        "~" => "", "–" => "-", "’" => "'"
    );

    $str = str_replace(array_keys($invalid), array_values($invalid), $str);

    return $str;
}
function taggator_install()
{
    add_option("taggatorcs", '0');
    add_option("taggatormhw", '1');
    add_option("taggatorauto", '1');
    add_option("taggatortagtitle", '1');
    add_option("taggatortags", "Cities,sydney,paris,london\nAnimals,dog,cat,horse,labradoodle");
    add_option("taggatormintitle", "0");
    add_option("taggatorminbody", "1");
    add_option("taggatorbodyandtitle", "0");
    $cpt = array();
    $cpt["post"]["enabled"] = 1;
    $cpt["post"]["selected_tag"] = "post_tag";
    add_option("taggator_post_types", $cpt);
}
function taggator_uninstall()
{
    delete_option("taggatorcs");
    delete_option("taggatormhw");
    delete_option("taggatorauto");
    delete_option("taggatortagtitle");
    delete_option("taggatortags");
    delete_option("taggatormintitle");
    delete_option("taggatorbodyandtitle");
    delete_option("taggator_post_types");
}
?>